module Divisao (

input clk,
input [31:0] dividendo,
input [31:0] divisor,
output reg [31:0] quociente,
output reg [31:0] resto,
output reg div_Out,
input div_In

);


integer contador;
reg [2:0] current_State;
reg [63:0] temp_Resto;

initial begin
    current_State = 3'b000;
    temp_Resto = 64'd0;
end

always @ (posedge clk) begin
   
    if (div_In == 1'b1) begin

        case (current_State)
       
            3'b000: begin
       
                    temp_Resto [63:0] = { 32'd0, dividendo } ;
                    
                    current_State = 3'b001;
                    contador = 0;
                   
            end


            3'b001:    begin
                    temp_Resto = temp_Resto << 1;
                    
                    current_State = 3'b010;
            end


            3'b010: begin
                    temp_Resto [63:32] = temp_Resto [63:32] - divisor;
                    
                    if ( temp_Resto[63] == 1'b1 ) begin
                        current_State = 3'b011;
                    end else begin
                        current_State = 3'b100;
                    end
            end

            3'b011:    begin
                    temp_Resto [63:32] = temp_Resto [63:32] + divisor;
                    temp_Resto  = temp_Resto << 1;
                    
                    current_State = 3'b101;
            end

            3'b100:    begin
                   
                    temp_Resto  = temp_Resto << 1;
                    temp_Resto = temp_Resto + 64'd1;
               
                   
                    //temp_Resto = { temp_Resto[62:0], 1'b1 } ;
                    
                    current_State = 3'b101;
            end

            3'b101: begin
                    contador = contador + 1;
                   
                    if ( contador == 32) begin
                        current_State = 3'b110;
                    end else begin
                        current_State = 3'b010;
                    end
            end

            3'b110: begin
                    temp_Resto [63:32] = temp_Resto [63:32] >> 1;
                    
                    resto = temp_Resto [63:32];
                    quociente = temp_Resto [31:0];
                    current_State = 3'b000;
                    div_Out = 1'b1;
                   
            end
        endcase
    end
end

endmodule
