module MuxMemToReg(MemToReg, in_MDR, in_AluOut, in_Shift, in_Lo, in_Hi, in_regA, in_Sll_16, in_SgnExt1_32, in_pc, out_MemToReg);
	input [3:0] MemToReg; // seletor
	input [31:0] in_MDR;
	input [31:0] in_AluOut;
	input [31:0] in_Shift;
	input [31:0] in_Lo;
	input [31:0] in_Hi;
	input [31:0] in_regA;
	input [31:0] in_Sll_16;
	input [31:0] in_SgnExt1_32;
	input [31:0] in_pc;
	output reg [31:0] out_MemToReg;
	
	always @ (MemToReg) begin
		case (MemToReg)
			4'b0000: out_MemToReg = in_MDR;
			4'b0001: out_MemToReg = in_AluOut; // 253 em binario
			4'b0010: out_MemToReg = in_Shift; // 254 em binario
			4'b0011: out_MemToReg = in_Lo; // 255 em binario
			4'b0100: out_MemToReg = in_Hi;
			4'b0101: out_MemToReg = in_regA;
			4'b0110: out_MemToReg = in_Sll_16;
			4'b0111: out_MemToReg = in_SgnExt1_32;
			4'b1000: out_MemToReg = in_pc;
			default: out_MemToReg = 0;
		endcase
	end
	
endmodule